/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;

public class DepositXDialog extends Dialog implements Runnable
{
    // This reference is passed in by the constructor
    MicroFabControl _control;

    Thread _thread;

	public DepositXDialog(Frame parent, boolean modal)
	{
		super(parent, modal);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(380,157);
		label1 = new java.awt.Label("X displacement (mm): ",Label.RIGHT);
		label1.setBounds(12,36,132,24);
		add(label1);
		xDisplacement = new java.awt.TextField();
		xDisplacement.setBounds(144,36,96,24);
		add(xDisplacement);
		cancel = new java.awt.Button();
		cancel.setLabel("Cancel");
		cancel.setBounds(264,36,60,24);
		cancel.setBackground(new Color(12632256));
		add(cancel);
		label2 = new java.awt.Label("status: ",Label.RIGHT);
		label2.setBounds(12,60,48,24);
		add(label2);
		status = new java.awt.Label("");
		status.setBounds(60,60,312,24);
		add(status);
		label3 = new java.awt.Label("X (mm): ",Label.RIGHT);
		label3.setBounds(0,60,72,24);
		add(label3);
		xPosition = new java.awt.Label("");
		xPosition.setBounds(72,84,108,24);
		add(xPosition);
		label4 = new java.awt.Label("Z (mm): ",Label.RIGHT);
		label4.setBounds(12,108,60,24);
		add(label4);
		zPosition = new java.awt.Label("");
		zPosition.setBounds(72,108,108,24);
		add(zPosition);
		label5 = new java.awt.Label("Deposit up to Z (mm): ",Label.RIGHT);
		label5.setBounds(12,12,132,24);
		add(label5);
		label6 = new java.awt.Label("X (mm): ",Label.RIGHT);
		label6.setBounds(12,84,60,24);
		add(label6);
		zTop = new java.awt.TextField();
		zTop.setBounds(144,12,96,24);
		add(zTop);
		label7 = new java.awt.Label("Z level: ",Label.RIGHT);
		label7.setBounds(192,108,48,24);
		add(label7);
		zLevelStatus = new java.awt.Label("");
		zLevelStatus.setBounds(240,108,84,24);
		add(zLevelStatus);
		setTitle("Deposit X");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymFocus aSymFocus = new SymFocus();
		xDisplacement.addFocusListener(aSymFocus);
		SymAction lSymAction = new SymAction();
		xDisplacement.addActionListener(lSymAction);
		cancel.addActionListener(lSymAction);
		zTop.addFocusListener(aSymFocus);
		zTop.addActionListener(lSymAction);
		//}}		
	}

	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public DepositXDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public DepositXDialog(Frame parent, MicroFabControl control, boolean modal)
	{
		this(parent, modal);
		_control = control;
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();

			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
        else {
          // Hiding, so stop the thread
	      if (_thread != null) {
		    _thread.stop();
		    _thread = null;
		    // Thread may have turned on the voltage
            _control.setVTriggerState (0);
		  }
        }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.TextField xDisplacement;
	java.awt.Button cancel;
	java.awt.Label label2;
	java.awt.Label status;
	java.awt.Label label3;
	java.awt.Label xPosition;
	java.awt.Label label4;
	java.awt.Label zPosition;
	java.awt.Label label5;
	java.awt.Label label6;
	java.awt.TextField zTop;
	java.awt.Label label7;
	java.awt.Label zLevelStatus;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowActivated(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DepositXDialog.this)
				DepositXDialog_WindowActivated(event);
		}

		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DepositXDialog.this)
				Dialog1_WindowClosing(event);
		}
	}

	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == xDisplacement)
				xDisplacement_FocusLost(event);
			else if (object == zTop)
				zTop_FocusLost(event);
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == xDisplacement)
				xDisplacement_FocusGained(event);
			else if (object == zTop)
				zTop_FocusGained(event);
		}
	}

	void xDisplacement_FocusGained(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.

		//{{CONNECTION
		// Select all of the text
		xDisplacement.selectAll();
		//}}
	}

	void xDisplacement_FocusLost(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.

		//{{CONNECTION
		// Select none of the text
		xDisplacement.select(0,0);
		//}}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == xDisplacement)
				xDisplacement_EnterHit(event);
			else if (object == cancel)
				cancel_ActionPerformed(event);
			else if (object == zTop)
				zTop_EnterHit(event);
		}
	}

	void xDisplacement_EnterHit(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
        if (_thread != null)
          // This really shouldn't happen because we did setEnable(false) for the first thread
          return;
          
        if (xDisplacement.getText().equals ("")) {
            // User did not enter a value
            status.setText ("ERROR: Enter value for X displacement");
            return;
        }
    
		// Disable the TextField
		xDisplacement.setEnabled(false);
		zTop.setEnabled(false);

		// Highlight the cancel button
		cancel.requestFocus();

        // Start the thread
        _thread = new Thread (this);
		_thread.start();

		//{{CONNECTION
		//}}
	}

    public void run ()
    {
        boolean ccwX, error = false;
        final double mmPerStep = _control.MM_PER_REV/_control.STEPS_PER_REV;
        // Steps per hop is hop size in mm / mmPerStep.  Used for both Z and horizontal hops
        final double mmHorizontalHop = .025;
        // How far to go up before dropping back down
        final double mmVerticalHop = .025;
        final double mmZIncrement = .0001;
        double z;

		double displacement = Double.valueOf (xDisplacement.getText()).doubleValue();
        if (displacement < 0.)
          // negative displacement
          ccwX = true;
        else
          ccwX = false;

		double zMax = Double.valueOf (zTop.getText()).doubleValue();

	    // Turn off motor standby.
        _control.doutClearBits (_control.DOUT_STANDBY);

        // Do an initial lowering to get a sense of where we think the surface is
        
        if (!LowerProbeDialog.lowerProbeHelper (_control, status))
          //error
          return;          

        showPositions ();
                
        // Rely on reading _control to track our progress
        int startingXSteps = _control.xSteps();

        // The probe is lowered, so start from here and step up to zMax
        for (double zLevel = _control.zSteps() * mmPerStep;
             zLevel < zMax; zLevel += mmZIncrement) {
          zLevelStatus.setText (String.valueOf (zLevel));
          
          while (true) {
            if (!LowerProbeDialog.lowerProbeHelper (_control, status)) {
              error = true;
              break;
            }
            showPositions ();

            // Compute distance to where we want to deposit to
            z = (zLevel + mmZIncrement) - _control.zSteps()*mmPerStep;
            if (z > 0.) {
              if (!DepositZDialog.depositZHelper (z, 2.0, _control, status)) {
                error = true;
                break;
              }
            }
            
            showPositions ();
            
            // Move up a hop.
            for (int i = 0; i < (int)(mmVerticalHop / mmPerStep); ++i)
              _control.zStep (false);
          
            // Read abs values of distance, since ccwX will move the correct direction
            if (Math.abs ((_control.xSteps() - startingXSteps)*mmPerStep) >= Math.abs(displacement)) {
              // We reached the horizontal displacement
              error = false;
              break;
            }
          
            // Move over a hop based on ccwX
            for (int i = 0; i < (int)(mmHorizontalHop / mmPerStep); ++i) {
              _control.xStep (ccwX);              
            }
          }          
          
          if (error) {
            // Inner loop cause an error, so quit
            showPositions();
            break;
          }
            
          // Z is lifted up, so run in reverse X to starting position
          while (_control.xSteps() != startingXSteps)
            // Go in opposite direction.
            _control.xStep (!ccwX);
        }
        
        zLevelStatus.setText ("");
        status.setText ("Finished.");

		cancel.setLabel("Close");
        // Don't try to close the window inside the thread.  Let the user close it.
    }

	void cancel_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		//{{CONNECTION
		// Hide the Dialog
		setVisible(false);
		//}}
	}

	void showPositions ()
	{
		xPosition.setText (String.valueOf ((_control.MM_PER_REV/_control.STEPS_PER_REV) * _control.xSteps()));
		zPosition.setText (String.valueOf ((_control.MM_PER_REV/_control.STEPS_PER_REV) * _control.zSteps()));
	}

	void zTop_FocusGained(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select all of the text
		zTop.selectAll();
		//}}
	}

	void zTop_FocusLost(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select none of the text
		zTop.select(0,0);
		//}}
	}

	void DepositXDialog_WindowActivated(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		showPositions();
			 
		//{{CONNECTION
		// Request the focus
		xDisplacement.requestFocus();
		//}}
	}

	void zTop_EnterHit(java.awt.event.ActionEvent event)
	{
	    // Do the same as hitting Enter in xDisplacement
	    xDisplacement_EnterHit (null);
	}
}
