/* Header for class RealTime */
#include "RealTime.h"
#include "c:\Nidaqnt\Include\nidaqex.h" // Nidaq Library
#include <Wtypes.h>
#include <Winbase.h>
typedef struct _TIME {
	unsigned long low;
	unsigned long high;
	} TIME;
static jdouble second, s, freq=0., period=0.;
// Global Variables
    i16 iStatus = 0;
    i16 iRetVal = 0;
    i16 iDevice = 1;
    i16 iChan = 1;
    i16 iGain = 1;
    f64 dVoltage = 0.0;
    i16 iIgnoreWarning = 0;
	i16 ipattern = 0;
	i16 iport = 0;
	i16 imode = 0;
	i16 idir = 1;

JNIEXPORT jdouble JNICALL Java_RealTime_adc
(JNIEnv *e, jobject obj, jint iChan) {

   iStatus = AI_VRead(iDevice, iChan, iGain, &dVoltage);

   //iRetVal = NIDAQErrorHandler(iStatus, "AI_VRead", iIgnoreWarning);
   return((jdouble)dVoltage);
}

JNIEXPORT void JNICALL Java_RealTime_dac
(JNIEnv *e, jobject obj, jint iChan, jdouble dVoltage) {
    iStatus = AO_VWrite(iDevice, iChan, dVoltage);
}

JNIEXPORT void JNICALL Java_RealTime_DigOut
(JNIEnv *e, jobject obj, jint ipattern) {
	iStatus = DIG_Out_Port(iDevice, iport, ipattern);
}

JNIEXPORT void JNICALL Java_RealTime_DigPrtConfig
(JNIEnv *e, jobject obj) {
	iStatus = DIG_Prt_Config(iDevice, iport, imode, idir);
}
/*
 * Class:     RealTime
 * Method:    timer
 * Signature: ()D
 */
JNIEXPORT jdouble JNICALL Java_RealTime_second
(JNIEnv * env, jclass cl) {
	static TIME Time, Freq;
	static double Dt;
	static double MS = (2.*(double)((unsigned)1<<31));

	if( period==0. ) {
		QueryPerformanceFrequency((LARGE_INTEGER *)(&Freq) );
		freq=(double)Freq.low;
		period=(1./freq);
	}
	QueryPerformanceCounter((LARGE_INTEGER *)(&Time));
	second = (MS*Time.high+(double)Time.low)/freq;
	return (second);  // return time in seconds as double
}

/*
 * Class:     RealTime
 * Method:    spinloop
 * Signature: (D)D
 */
JNIEXPORT jdouble JNICALL Java_RealTime_timer
(JNIEnv * env, jclass cl, jdouble DT) {
	static TIME Time, Freq;
	static double Dt;
	static double MS = (2.*(double)((unsigned)1<<31));

	if( DT>0. ) {
		Dt = DT;
		QueryPerformanceFrequency((LARGE_INTEGER *)(&Freq) );
		freq=(double)Freq.low;
		period=(1./freq);
		QueryPerformanceCounter((LARGE_INTEGER *)(&Time));
		second = (MS*Time.high+(double)Time.low)/freq;
		return(0);
	}
	s = second + Dt;
	do {
		QueryPerformanceCounter((LARGE_INTEGER *)(&Time));
		second = (MS*Time.high+(double)Time.low)*period;
	}while(second<s);
	return (second);  // return time in seconds as double

}
